/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.web.rich.context.support;

import javax.servlet.http.HttpServletRequest;

/**
 * NXׂC^tF[XB
 * 
 * <p>
 * t[[NT[rXw̃NX́A{C^tF[X
 * ĂяoāAQƂ邱ƂoB
 * </p>
 * 
 * <p>
 * {C^tF[XĂяoۂ́A{C^tF[X̎NXDIReiݒ肵ėpB
 * ʏ͎NXƂāADefaultRequestContextSupportImpl𗘗p΂悢B
 * DefaultRequestContextSupportImplł͋Ɩ̗vȂꍇɂ̂݁A
 * ۃNXAbstractRequestContextSupport܂͖{C^tF[X
 * Ɩv𖞂NX쐬Ap邱ƁB
 * </p>
 * 
 * <p>
 * QƂNX́Aȉ̂悤Bean`邱ƁB
 * </p>
 * 
 * <p>
 * y<code>Bean`t@C</code>̐ݒz<br>
 * <code><pre>
 *  &lt;bean id="xxxx" class="xxxx.Xxx"&gt;
 *    &lt;property name="ctxSupport" ref="ctxSupport"/&gt;
 *  &lt;/bean&gt;
 *  ctxSupport́ARequestContextSupportNXBean`B
 *  ڍׂ́A{C^tF[X̎NXQƂ邱ƁB
 * </pre></code>
 * </p>
 * 
 * <p>
 * QƂۂ̎Aȉɂ߂B
 * </p>
 * 
 * <p>
 * y<code>Xxx.java</code>̎z<br>
 * <code><pre>
 * public class Xxx {
 *   // Œ`
 *   RequestContextSupport ctxSupport;
 *   // Zb^[p(DIReiɂs)
 *   public void setCtxSupport(RequestContextSupport ctxSupport) {
 *       this.ctxSupport = ctxSupport;
 *   }
 *   // QƂ郍WbN
 *   protected void execute(String urlPath) {
 *   @        EEEE
 *       String requestName = ctxSupport.getRequestName();
 *       EEEE
 *   }
 * }
 * </pre></code>
 * </p>
 */
public interface RequestContextSupport {
    /**
     *@NGXg擾B
     *
     * @return NGXg
     */
    String getRequestName();

    /**
     * ƖvpeB擾B
     * VXeƂɓƎɕێ́Ã\bhŎ擾B
     *
     * @param key L[
     * @return ƖvpeB
     */
    Object getProperty(String key);


    /**
     * ԋpľ^w肵āAƖvpeB擾B
     * ƖƂɓƎɕێ́Ã\bhŎ擾B
     *
     * @param key L[
     * @param <E> ԋpľ^
     * @return ƖvpeB
     */
    <E> E getProperty(String key, Class<E> clazz);
    
    /**
     * String^̋ƖvpeB擾B
     * ƖƂɓƎɕێ́Ã\bhŎ擾B
     *
     * @param key L[
     * @return ƖvpeB
     */
    String getPropertyString(String key);
    
    
    /**
     * 𐶐B
     * @param request HTTPNGXg
     */
    void generateContext(HttpServletRequest request);
    
    /**
     * jB
     */
    void destroyContext();
}
